#import "MessageServer.h"
#import <objc/objc.h>

#define NUMMACHINES 11
#define NUMMESSAGES 100 

void main()
{
	char *machine, *command;
	int count, inport, fd2p, queuedMessages, backlog;
	port_t localPort;
	kern_return_t  error;
	struct servent *serverEntry;
 	msg_return_t returnCode;
	BOOL notDone = YES;
	int machineNum, messageNum;
	int returnedMessages[NUMMACHINES][NUMMESSAGES];
	boolean_t owner, rights;
	port_name_t portSetName;

	// This array will keep track of messages that have been received.
	for(count = 0; count < NUMMACHINES; count++)
		bzero(returnedMessages[count], NUMMESSAGES * sizeof(int));

 	// Set up a port to which clients can send their messages.
	if ((error=port_allocate(task_self(), &localPort)) != KERN_SUCCESS) 
	{
    	mach_error("port_allocate failed", error); 
    	exit(1);
	}
	
	// Advertise this port.
	if((error = netname_check_in(name_server_port, "MESSAGESERVER", PORT_NULL,
			localPort)) != NETNAME_SUCCESS)
	{
    	mach_error("netname_check_in failed", error); 
		exit(1);
	}	
 
	// Start the clients running.
	serverEntry = getservbyname("exec", "tcp");	
	inport = serverEntry->s_port;
	command = (char *)malloc(200);
	strcpy(command, "/Net/gator4/Academic/Technical/DeveloperStuff/"
				"Source/Current/HAndF/MessageClient");

	machine = (char *)malloc(8);
 	for(count = 1; count < NUMMACHINES; count++)
 	{
 		sprintf(machine, "quig%d", count+11);
		if(fork()==0)
		{
			rexec(&machine, inport, *******, *******, command, &fd2p);
			exit(0);
		}
 	}	

//	free(command);
//	free(machine);

	printf("starting server loop\n");

	// Set up the message header for messages we will receive from clients.
	messageFromClient.msgHeader.msg_local_port = localPort;
	messageFromClient.msgHeader.msg_size = sizeof(struct messageStruct);

	// Set the queue to its maximum size.
	port_set_backlog(task_self(), localPort, PORT_BACKLOG_MAX);

	// Sit here and wait for messages from the clients.
	while(notDone)
	{
/*		// See how full the queue is.
		error = port_status(task_self(), localPort, &portSetName,
				&queuedMessages, &backlog, &owner, &rights);
		if(queuedMessages > 15)
       		printf("queued messages %d, backlog %d\n", queuedMessages,
					backlog);
*/
		// Waiting for messages from clients.
		returnCode = msg_receive(&messageFromClient.msgHeader, 
				MSG_OPTION_NONE, 0);
		if(returnCode == RCV_SUCCESS)
		{
			machineNum = messageFromClient.machineNumber;
			messageNum = messageFromClient.data;

			returnedMessages[machineNum-11][messageNum] = 1;
 			if((messageNum+1) == NUMMESSAGES)
			{
				printf("machine %d is done\n", machineNum);
//				for(count = 0; count < NUMMESSAGES; count++)
//					printf("%d ", returnedMessages[machineNum-11][count]);
//				printf("\n\n");
			}

 			if(messageNum > 0)
				if(returnedMessages[machineNum-11][messageNum-1] == 0)
					printf("message %d from quig%d was lost\n", messageNum-1,
							machineNum);
		}
		else
			printf("return code = %d\n", returnCode);
	}
	return;
}	
